
#property indicator_separate_window
#property indicator_buffers    2
#property indicator_maximum    1
#property indicator_minimum    0.2
#property indicator_color1     LimeGreen
#property indicator_color2     Red
#property indicator_width1     1
#property indicator_width2     2
#property indicator_level1     0.30
#property indicator_level2     0.50
#property indicator_level3     0.70
#property indicator_level4     0.90
#property indicator_levelcolor MediumOrchid

//
//
//
//
//

extern string note_TimeFrames        = "M1;5,15,30,60H1;240H4;1440D1;10080W1;43200MN|0-CurrentTF";
extern string TimeFrame              = "Current time frame";
extern int    LongBandsPeriod        = 55;
extern int    LongBandsMode          = 0;
extern int    LongBandsPrice         = 0;
extern double LongBandsDeviations    = 2.2;
extern int    ShortBandsPeriod       = 14;
extern int    ShortBandsMode         = 0;
extern int    ShortBandsPrice        = 0;
extern double ShortBandsDeviations   = 2.2;
extern int    PERIODS_CHARACTERISTIC = 100;
extern double SmoothLength           = 5.0;
extern double SmoothPhase            = 0.0;
extern bool   SmoothDouble           = true;
extern bool   Interpolate            = true;

extern bool   alertsOn               = true;
extern bool   alertsOnCurrent        = false;
extern bool   alertsMessage          = true;
extern bool   alertsSound            = false;
extern bool   alertsEmail            = false;

//
//
//
//
//

double Shortoscillator[];
double Longoscillator[];
double ShortDev[];
double LongDev[];
double LongBollMd[];
double ShortBollMd[];
double trend[];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//
//
//
//
//

int init()
  {
   IndicatorBuffers(7);   
   SetIndexBuffer(0,Shortoscillator);
   SetIndexBuffer(1,Longoscillator);
   SetIndexBuffer(2,ShortDev); 
   SetIndexBuffer(3,LongDev); 
   SetIndexBuffer(4,LongBollMd); 
   SetIndexBuffer(5,ShortBollMd);
   SetIndexBuffer(6,trend);
   
   //
   //
   //
   //
   //
   
   indicatorFileName = WindowExpertName();
   calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
   returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
   
   //
   //
   //
   //
   //
   
   IndicatorShortName(timeFrameToString(timeFrame)+  "  wave-pm smooth ");
   

  return(0);
  }
  
//
//
//
//
//

int deinit(){ return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int start()
  {
   int counted_bars=IndicatorCounted();
   int i,j,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit=MathMin(Bars-1,Bars-counted_bars-1);
         if (returnBars) { Shortoscillator[0] = limit+1; return(0); }
           
    //
    //
    //
    //
    //
           
    if (calculateValue || timeFrame == Period())
    {
    
    
      for(i = limit; i >= 0; i--)
      {
      
      double Longsum  = 0.0;
      double Shortsum = 0.0;
      LongBollMd[i]   = iMA(NULL,0,LongBandsPeriod, 0,LongBandsMode, LongBandsPrice, i);
      ShortBollMd[i]  = iMA(NULL,0,ShortBandsPeriod,0,ShortBandsMode,ShortBandsPrice,i);
      
      //
      //
      //
      //
      //
      
      for(j=0; j<LongBandsPeriod; j++)
      {
      double Longpr  = iMA(NULL,0,1,0,MODE_SMA,LongBandsPrice,i+j);
             Longsum+=(Longpr-LongBollMd[i])*(Longpr-LongBollMd[i]);
      }
      
      //
      //
      //
      //
      //
      
      for(j=0; j<ShortBandsPeriod; j++)
      {
      double Shortpr  = iMA(NULL,0,1,0,MODE_SMA,ShortBandsPrice,i+j);
             Shortsum+=(Shortpr-ShortBollMd[i])*(Shortpr-ShortBollMd[i]);
      }
      
      //
      //
      //
      //
      //
      
      LongDev[i]         = MathSqrt(Longsum/LongBandsPeriod);
      Longoscillator[i]  = iDSmooth(OscillatorLine(LongDev,i),SmoothLength,SmoothPhase,SmoothDouble,i,  0);
      ShortDev[i]        = MathSqrt(Shortsum/ShortBandsPeriod);
      Shortoscillator[i] = iDSmooth(OscillatorLine(ShortDev,i),SmoothLength,SmoothPhase,SmoothDouble,i,20);
                trend[i] = trend[i+1];
      
      if (Longoscillator[i] > Longoscillator[i+1] && Shortoscillator[i] > Shortoscillator[i+1]) trend[i]=  1;  
      if (Longoscillator[i] < Longoscillator[i+1] && Shortoscillator[i] < Shortoscillator[i+1]) trend[i]=  -1;  

       manageAlerts();
     }
     

   return(0);
  }
  
  //
  //
  //
  //
  //

  limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   
   for (i=limit;i>=0; i--)
   {
   int        y       = iBarShift(NULL,timeFrame,Time[i]);
   
   Shortoscillator[i] = iCustom(NULL,timeFrame,indicatorFileName,"","calculateValue",LongBandsPeriod,LongBandsMode,LongBandsPrice,LongBandsDeviations,ShortBandsPeriod,ShortBandsMode,ShortBandsPrice,ShortBandsDeviations,PERIODS_CHARACTERISTIC,SmoothLength,SmoothPhase,SmoothDouble,0,y);
   Longoscillator[i]  = iCustom(NULL,timeFrame,indicatorFileName,"","calculateValue",LongBandsPeriod,LongBandsMode,LongBandsPrice,LongBandsDeviations,ShortBandsPeriod,ShortBandsMode,ShortBandsPrice,ShortBandsDeviations,PERIODS_CHARACTERISTIC,SmoothLength,SmoothPhase,SmoothDouble,1,y);
   trend[i]           = iCustom(NULL,timeFrame,indicatorFileName,"","calculateValue",LongBandsPeriod,LongBandsMode,LongBandsPrice,LongBandsDeviations,ShortBandsPeriod,ShortBandsMode,ShortBandsPrice,ShortBandsDeviations,PERIODS_CHARACTERISTIC,SmoothLength,SmoothPhase,SmoothDouble,6,y);
   
   //
   //
   //
   //
   //
   
   if (timeFrame <= Period() || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
   if (!Interpolate) continue;
   
   //
   //
   //
   //
   //
         
   datetime time = iTime(NULL,timeFrame,y);
      for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
      double factor = 1.0 / n;
      for(j = 1; j < n; j++)
      {
  	   Shortoscillator[i+j] = j*factor*Shortoscillator[i+n] + (1.0-j*factor)* Shortoscillator[i];
  	   Longoscillator[i+j]  = j*factor*Longoscillator[i+n]  + (1.0-j*factor)* Longoscillator[i];

      }
   }

   //
   //
   //
   //
   //
   manageAlerts(); 
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
} 

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

double OscillatorLine(double indicator[], int StartBar)
  {
      double S=0;
      int ArrayLong=PERIODS_CHARACTERISTIC;
      double Result;
      for(int j=StartBar;j<ArrayLong+StartBar;j++) 
        {S+=MathPow((indicator[j]/Point),2);}
      
      S/=ArrayLong;
      S=MathSqrt(S)*Point;
      if(S!=0) 
        {Result=indicator[StartBar]/S;}
      Result=MathTanh(Result);
      return (Result);
  }
double MathTanh(double x)
{ 
   double exp;
   double returnNum;
   if(x>0)
     {
       exp=MathExp(-2*x);
       returnNum= (1-exp)/(1+exp);
       return (returnNum);
     }
   else
     {
       exp=MathExp(2*x);
       returnNum=(exp-1)/(1+exp);
       return (returnNum);
     }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

double wrk[][40];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(double price, double length, double phase, bool isDouble, int i, int s=0)
{
   if (isDouble)
         return (iSmooth(iSmooth(price,MathSqrt(length),phase,i,s),MathSqrt(length),phase,i,s+10));
   else  return (iSmooth(price,length,phase,i,s));
}

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}


void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"up");
         if (trend[whichBar] == -1) doAlert(whichBar,"no trend");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," wave pm changed direction to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," wave-pm "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

